<!DOCTYPE html>
<html>

  <!-- JQuery -->
  <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
  <script src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.11.1/jquery-ui.min.js"></script>
  <script type="text/javascript" src="jquery.hotkeys.js"></script>
  <script type="text/javascript" src="jquery.ba-hashchange.min.js"></script>

  <!-- Bootstap -->
  <link href="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css" rel="stylesheet" media="screen">
  <link href="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap-theme.min.css" rel="stylesheet" media="screen">
  <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>

  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="GEN Register visualisation tool">
    <meta name="author" content="Chris Cummins">
    <title>GEN Register Regions</title>

    <div class="navbar navbar-default" style="margin-bottom: 5px; min-height: 25px;">
      <div class="navbar-inner" style="padding-bottom: 4px">
        <a class="brand navbar-brand" href=""
           style="padding: 5px 30px 5px 10px; height: auto;">GEN Regions</a>
        <div class="btn-group">
          <a id="exec-size-btn" class="btn dropdown-toggle btn-default"
             data-toggle="dropdown" href="#" style="width: 64px;">
            ExecSize <span class="caret"></span>
          </a>
          <ul id="exec-size-ul" class="dropdown-menu" role="menu"
              aria-labelledby="dLabel">
            <li>ExecSize</li>
            <li class="divider"></li>
            <li><a>1</a></li>
            <li><a>2</a></li>
            <li><a>4</a></li>
            <li id="default-exec-size-li"><a>8</a></li>
            <li><a>16</a></li>
            <li><a>32</a></li>
          </ul>
        </div> <!-- /.btn-group -->
        &nbsp;
        <input id="region-form" type="text" style="border-radius: 4px;"
               placeholder="Region" style="position: relative; top: 3px;"
               >&nbsp;
        <div class="btn-group pull-right">
          <button id="share-btn" class="btn btn-default" onclick="shareBtnCb();">
            <strong>Share</strong>
          </button>
          <button id="share-btn" class="btn btn-default" onclick="toggleHelpModal();">
            <strong>Help</strong>
          </button>
        </div> <!-- /.btn-group -->
      </div>
    </div> <!-- /.navbar -->
  </head>

  <body>
    <div class="row">
      <div class="span11">
        <div id="share" class="alert alert-success">
          <button type="button" class="close">
            &times;
          </button>
          <strong>URL Hash</strong>
          <textarea id="share-hash" class="text"
                    style="width: 400px; height: 20px; resize: none;"
                    readonly></textarea>
        </div> <!-- /.alert -->
        <div id="alert-error" class="alert alert-error">
          <button type="button" class="close">
            &times;
          </button>
          <div id="alert-error-placeholder"></div>
        </div> <!-- /.alert -->
        <div id="alert" class="alert">
          <button type="button" class="close">
            &times;
          </button>
          <div id="alert-placeholder"></div>
        </div> <!-- /.alert -->
      </div> <!-- /.span11 -->
    </div> <!-- /.row -->
    <div class="container">
      <div class="row">
        <div class="span11">
          <canvas id="canvas" width="900" height="412">
            Unsupported browser!
          </canvas>
        </div> <!-- /.span11 -->
      </div> <!-- /.row -->
      <div class="span11">
        <div class="row">
          <p id="canvas-caption"></p>
        </div> <!-- /.row -->
        <div class="row">
        </div> <!-- /.row -->
      </div> <!-- /.span11 -->
    </div> <!-- /.container -->

    <!-- Modal -->
    <div class="modal fade" id="helpModal" tabindex="-1" role="dialog" aria-labelledby="helpModalLabel" aria-hidden="true">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
            <h4 class="modal-title" id="helpModalLabel">Help</h4>
          </div>
          <div class="modal-body">
            <ol>
              <li>Select an execution size from the dropdown box.</li>
              <li>Enter a register region description into the text area.</li>
            </ol>
            <h2>Sharing</h2>

            The page URL contains a description of the currently visible region
            which can be shared, saved or bookmarked for later reference. For
            example, <code>file:///path/to/gen-regions.html#execsize=8&amp;region=1.0<1>:F</code>.
            Since this is a path to a local file, you may want to use the Share
            button to copy just the relevant part since other people's local paths
            may not match (these URL hashes can be copied onto the end of the file
            path or alternatively pasted directly into the region text box and
            submitted like a normal region description).
            <h2>Key Bindings</h2>
            The following page-wide keybindings are defined for convenience:
            <br/><br/>
            <table cellspacing="20" style="position: relative; left: 30px;">
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>[return]</code></strong></td>
                <td>Submit region</td>
              </tr>
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>[escape]</code></strong></td>
                <td>Dismiss warnings</td>
              </tr>
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>e</code></strong></td>
                <td>Toggle through execution sizes</td>
              </tr>
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>r</code></strong></td>
                <td>Focus on region text box</td>
              </tr>
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>c</code></strong></td>
                <td>Clear region text box</td>
              </tr>
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>s</code></strong></td>
                <td>Share</td>
              </tr>
              <tr>
                <td style="text-align: right; padding-right: 10px;">
                  <code><strong>?</code></strong></td>
                <td>Help</td>
              </tr>
            </table><br/><br/>
          </div>
        </div>
      </div>
    </div>

  </body>

  <!-- GEN Regions -->
  <script type="text/javascript" src="Regions.js"></script>
  <script>init();</script> <!-- Bootstrap our script. -->
  <noscript>JavaScript support unavailable!</noscript>

</html>
